#pragma once
#include "PoroMediaDialogShare.h"
#include "SphereInput.h"
#include "SphereGrowth.h"
#include "afxwin.h"

// SphereDialog dialog

class SphereDialog : public CDialog, public PoroMediaDialogShare
{
	DECLARE_DYNAMIC(SphereDialog)

public:
	SphereDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~SphereDialog();

// Dialog Data
	enum { IDD = IDD_SPHERE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();

public:
	CButton		check_calc_even_diam;
	CButton		check_boundary_is_solid;
	CButton		check_conserve_memory;
	CButton		check_use_dist_xfrm;
	CButton		check_save_diameter_map_gray;
	CButton		check_save_diameter_map_rgb;
	CButton		check_save_sphere_map_gray;
	CButton		check_save_sphere_map_rgb;
	CButton		check_pad_distribution;

	CComboBox	combo_stop_after_point;
	CEdit		field_xfrm_face_cntrl;
	float		field_xfrm_face_float;	
	CEdit		field_xfrm_edge_cntrl;
	float		field_xfrm_edge_float;	
	CEdit		field_xfrm_corner_cntrl;
	float		field_xfrm_corner_float;

	//general
	afx_msg void OnBnClickedButtonInputDirectory();
	afx_msg void OnBnClickedButtonWorkDirectory();
	afx_msg void OnCbnSelchangeComboThresholdingMethod();
	afx_msg void OnBnClickedStop();
	afx_msg void OnEnChangeEditWidthSlices();
	afx_msg void OnEnChangeEditEndSlice();
	afx_msg void OnEnChangeEditWidthx();
	afx_msg void OnEnChangeEditEndx();
	afx_msg void OnEnChangeEditWidthy();
	afx_msg void OnEnChangeEditEndy();
	afx_msg void OnEnChangeEditStartSlice();
	afx_msg void OnEnChangeEditStartx();
	afx_msg void OnEnChangeEditStarty();
	afx_msg void OnEnChangeEditManualThreshold();
	//dialog specific

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonToggleAllSave();
	afx_msg void OnBnClickedCheckCalcEven();
	afx_msg void OnBnClickedCheckConserveMemory();
	afx_msg void OnBnClickedCheckUseDistXfrm();
};
